/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#ifndef __RTExternal_h__
#define __RTExternal_h__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTInSignal_h__
#include <RTInSignal.h>
#endif

#ifndef __RTProtocol_h__
#include <RTProtocol.h>
#endif

struct External
{
    class Base : public RTProtocol
    {
    public:
	static const RTProtocolDescriptor rt_class;

	RTS_INLINE Base( void );
		   ~Base( void );

	enum
	{
	    rti_event = rtiLast_RTProtocol + 1
	};

	// These two functions may be used only by the thread on which the
	// owner capsule executes.
	void enable( void );
	void disable( void );

	// This function may be used only on threads other than the one on
	// which the owner capsule executes.
	int raise( void );

	// This provides access to functions for managing deferred messages.
	RTS_INLINE RTInSignal event( void );

    protected:
	enum
	{
	    rtiLast_External = rti_event
	};

    private:
	RTMessage * msg;

	RTMessage * unload( void );

	static const RTSignalDescriptor rt_signals[];

	// unavailable methods
	Base( const Base & );
	Base & operator=( const Base & );
    };
};

#if RTS_INLINES
#include <RTExternal.inl>
#endif

#endif // __RTExternal_h__
