/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#ifndef __RTFieldOffset_h__
#define __RTFieldOffset_h__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTConfig_h__
#include <RTConfig.h>
#endif

typedef long RTFieldOffset;

#define RTOffsetOf( type, field ) \
    ( ( (RTFieldOffset)(char *)&( ((type *)sizeof( type ))->field ) ) \
      - (RTFieldOffset)                    sizeof( type )             )

#define RTObjectOf( type, offset, object ) \
    ( (type *)( ((char *)(object)) + (RTFieldOffset)(offset) ) )

#define RTConstObjectOf( type, offset, object ) \
    ( (const type *)( ((const char *)(object)) + (RTFieldOffset)(offset) ) )

#endif // __RTFieldOffset_h__
