/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#ifndef __RTInteger_inl__
#define __RTInteger_inl__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTInteger_h__
#include <RTInteger.h>
#endif

RTS_INLINE RTInteger::operator int ( void ) const
{
    return value;
}

RTS_INLINE int RTInteger::operator ~ ( void ) const
{
    return ~ value; //lint !e502
}

RTS_INLINE int RTInteger::operator ! ( void ) const
{
    return value == 0;
}

RTS_INLINE RTInteger & RTInteger::operator++( void )
{
    ++value;
    return *this;
}

RTS_INLINE RTInteger & RTInteger::operator--( void )
{
    --value;
    return *this;
}

#if INTEGER_POSTFIX

RTS_INLINE int RTInteger::operator++( int )
{
    return value++;
}

RTS_INLINE int RTInteger::operator--( int )
{
    return value--;
}

#endif

RTS_INLINE
RTTypedValue_RTInteger::
RTTypedValue_RTInteger( const RTInteger & _value )
    : data( &_value )
    , type( _value.getClassData() )
{
}

RTS_INLINE
RTTypedValue_RTInteger::
RTTypedValue_RTInteger( const RTInteger      & _value,
			const RTObject_class * _type )
    : data( &_value )
    , type( _type   )
{
}

#endif // __RTInteger_inl__
