/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#ifndef __RTMessageQ_h__
#define __RTMessageQ_h__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTConfig_h__
#include <RTConfig.h>
#endif

class RTMessage;
class RTQFilter;

class RTMessageQ
{
private:
    RTMessage             * head;
    RTMessage             * tail;

public:
			    RTMessageQ( void );
			    ~RTMessageQ( void );

    RTS_INLINE int          isEmpty( void ) const;
    int                     size( void ) const;

    int                     filterOne( RTQFilter & );
    int                     filterAll( RTQFilter & );

    void                    link( RTMessage * array, int );

    RTS_INLINE void         appendFrom( RTMessageQ & );
    void                    nqHead( RTMessage * );
    RTS_INLINE void         nqTail( RTMessage * );
    RTS_INLINE RTMessage  * dqHead( void );
    RTS_INLINE RTMessage  * dqAll( void );

private:
    // unavailable methods
    RTMessageQ( const RTMessageQ & );
    RTMessageQ & operator=( const RTMessageQ & );
};

#if RTS_INLINES
#include <RTMessageQ.inl>
#endif

#endif // __RTMessageQ_h__
