/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#ifndef __RTReal_h__
#define __RTReal_h__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTDataObject_h__
#include <RTDataObject.h>
#endif

#if RTREAL_INCLUDED

class RTReal : public RTDataObject
{
public:
    double                  value;

    explicit                RTReal( double = 0.0 );
			    RTReal( const RTReal & );
    virtual                 ~RTReal( void );

    RTReal                & operator=( double );
    RTReal                & operator=( const RTReal & );

    operator float          ( void ) const;
    operator double         ( void ) const;

    virtual int             operator==( const RTDataObject & ) const;

    virtual const RTObject_class * getClassData( void ) const;
    static  const RTObject_class   classData;

#define RTType_RTReal ( RTReal::classData )
};

struct RTTypedValue_RTReal
{
    const void           * data;
    const RTObject_class * type;

    RTS_INLINE RTTypedValue_RTReal( const RTReal         & ); //lint !e1931
    RTS_INLINE RTTypedValue_RTReal( const RTReal         &,
				    const RTObject_class * );
}; //lint !e1712

#if RTS_INLINES
#include <RTReal.inl>
#endif

#endif // RTREAL_INCLUDED

#endif // __RTReal_h__
