/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#ifndef __RTTcpSocket_h__
#define __RTTcpSocket_h__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTConfig_h__
#include <RTConfig.h>
#endif

class RTIOMonitor;

class RTTcpSocket
{
public:
		    RTTcpSocket( void );
		    ~RTTcpSocket( void );

    void            registerWith( RTIOMonitor * );

    int             create( void );
    void            close( void );

    int             listen( int port );
    int             acceptFrom( const RTTcpSocket & listener );

    int             getPrimary( char * ip_address ) const;
    static int      lookup( const char * host, char * ip_address );
    static int      lookup_numeric( const char * host, char * ip_address );

    int             connect( const char * address, int port );

    int             hasData( void );
    int             read( char *, int );
    int             write( const char *, int );

    enum State      { Closed, Listen, SynSent, Established };

    State           state( void );

    int             getLocalName( char *, int ) const;
    int             getLocalPort( void ) const;

#ifdef ENABLEIPv6
    enum            { IpAddressSize = 16 };
#else
    enum            { IpAddressSize = 4 };
#endif

protected:
    int             _sd;
    State           _state;
    RTIOMonitor   * _monitor;

    // support for non-blocking connect
    char            _peer_ip[ IpAddressSize ];
    int             _peer_port;

    int             try_connect( void );

private:
    // unavailable methods
    RTTcpSocket( const RTTcpSocket & );
    RTTcpSocket & operator=( const RTTcpSocket & );
};

#endif // __RTTcpSocket_h__
