/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#ifndef __RTTypeModifier_h__
#define __RTTypeModifier_h__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTConfig_h__
#include <RTConfig.h>
#endif

struct RTTypeModifier;

typedef int ( * RTNumberFunction )( const RTTypeModifier *,
				    const void           * record );

// This structure is used to describe common type structures
// more compactly that is possible with just RTObject_class.
//
// Field       Meaning
// -----       -------

struct RTTypeModifier
{
    RTNumberFunction    _num_elements_func;
    int                 _num_elements_const; // used only by RTNumberConstant
    int                 _indirect;
};

extern int RTNumberConstant( const RTTypeModifier *, const void * );

#endif // __RTTypeModifier_h__
