#! perl -w

# Licensed Materials - Property of IBM                       
# Component IBM Rational ROSE_RT BUILD : TARGET_RTS                 
# Copyright IBM Corporation 1999, 2008. All Rights Reserved.      
# U.S. Government Users Restricted Rights -  Use, duplication or    
# disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.



# This script is necessary because we might be running under Windows
# which severely limits command line lengths.

# Win9x command.com does not interact with perl according to win32 standard.
# We therefore need to call some functions in a non-standard way.
#
# This detects if the system is Win9x for that purpose.

sub mySystem
{
    my( $OS, $ROSERT_HOST );

    $OS          = '?' unless $OS          = $ENV{'OS'};
    $ROSERT_HOST = '?' unless $ROSERT_HOST = $ENV{'ROSERT_HOST'};

    if( $ROSERT_HOST eq 'win32' && $OS !~ m{^Windows_NT$}i )
    {
	return system( join( ' ', @_ ) );
    }
    else
    {
	return system( @_ );
    }
}

if( $#ARGV < 0 )
{
    print STDERR "ld.pl: Usage: $0 link options ...\n";
    exit 1;
}

$status   = 0;       # assume all is well
$cmdfile  = 'ld000'; # temporary filename pattern
@tmpfiles = ();      # list of temporary filenames

@command = ( shift @ARGV );

foreach $arg ( @ARGV )
{
    if( $arg =~ m{^%(.*)$} )
    {
	$in = $1;
	if( ! open( IN, "<$in" ) )
	{
	    print STDERR "ld.pl: Can't read '$in': $!\n";
	    $status = 1;
	}
	else
	{
	    ++$cmdfile;
	    $out = "$cmdfile.cmd";
	    if( ! open( OUT, ">$out" ) )
	    {
		print STDERR "ld.pl: Can't create $out\n";
		$status = 1;
	    }
	    else
	    {
		while( <IN> )
		{
		    s{$}{.o};
		    print OUT;
		}
		close( OUT );

		push @command, "-\@$out";
		push @tmpfiles, $out;
	    }
	    close( IN );
	}
    }
    else
    {
	push @command, $arg;
    }
}

if( $status == 0 )
{
    $status = &mySystem( @command );
}

unlink( @tmpfiles );

if( $status < 256 )
{
    exit $status;
}
else
{
    exit $status / 256;
}
