/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTActor.h>
#include <RTActorClass.h>
#include <RTActor_class.h>
#include <RTBindingEnd.h>
#include <RTRelayDescriptor.h>
#include <RTRelayPort.h>

int RTActor::_followIn( RTBindingEnd & end,
			int            relayId,
			int            repIndex,
			RTActorRef   * importer )
{
    if( relayId < 0 )
	return 0;

    const RTActor_class * info = getActorData();
    const RTActorClass  * type = info->type;

    if( relayId >= type->numRelays )
	return 0;

    RTRelayPort * relay = &     relays[ relayId ];
    int           size  = type->relays[ relayId ].replication;

    return relay->followIn( end, this, relayId, repIndex, size, importer );
}
