/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTActor.h>
#include <RTActorProbe.h>
#include <RTDebugger.h>
#include <RTMessage.h>
#include <RTSpecialPorts.h>
#include <RTSpecialSignals.h>

// initialize this actor in its RTS given that this thread is in sender

int RTActor::initMe( const void           * data,
		     const RTObject_class * type,
		     RTController         * sender )
{
#if USE_THREADS
    if( sender != context() )
	return sender->send( this, RTInitSignal, data, type, System );
    else
#endif
    {
	(void)sender; // it _is_ used

	RTMessage m;

	m.setPriority( System );
	m.setSignal( RTInitSignal );
	m.setDestination( this, (RTProtocol *)0, 0 );
	m.setData( data, type );

	msg = &m;

#if OBSERVABLE
	context()->debugger()->setTimestamp( &m, (RTProtocol *)0, 0 );

	if( probe != (RTActorProbe *)0 )
	    probe->evtMessageOutIn( &m, RTEventInfo::SendNormal );
#endif

#if LOG_MESSAGE
	logMsg();
#endif
	initializeAll();
	processHistory();

#if OBSERVABLE
	if( probe != (RTActorProbe *)0 )
	    probe->evtChain( 0 );
#endif

	msg = (const RTMessage *)0;

	return 1;
    }
}
