/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTAsciiDecoding.h>
#include <RTObject_class.h>

int RTAsciiDecoding::get_indirect( void                 * pointer,
				   const RTObject_class * target )
{
    int     status = 1;
    void ** link   = (void **)pointer;
    void  * value  = (void  *)0;
    void  * trash  = (void  *)0;

    if( getFieldListStart() == 0 )
    {
		int tag;

		if( get_int( tag ) == 0 || tag != 0 ) 
		{
			char byte;
			get_char(byte);

			if(byte != '\0')
				status = 0;
		}
    }
    else if( (value = target->allocate()) != (void *)0 )
    {
	target->init( value );

	if( target->decode( value, this ) == 0 )
	    status = 0;

	if( getFieldListFinish() == 0 )
	    status = 0;
    }

    if( status == 0 )
	trash = value;
    else
    {
	trash = *link;
	*link = value;
    }

    if( trash != (void *)0 )
	target->destroy( trash, RTObject_class::DestroyAndDeallocate );

    return status;
}
