/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTAsciiDecoding.h>
#include <RTFieldDescriptor.h>
#include <RTObject_class.h>

int RTAsciiDecoding::get_struct( void                 * target,
				 const RTObject_class * record )
{
    if( getFieldListStart() == 0 )
	return 0;

    int  status = 1;
    char name[ 200 ];

    while( getFieldName( name, (int)sizeof( name ) ) != 0 )
    {
	void                    * value = target;
	const RTObject_class    * type  = record;
	const RTFieldDescriptor * field;

	for(;;)
	{
	    field = type->_fields->lookup( type->_num_fields, name );

	    if( field != (const RTFieldDescriptor *)0 )
	    {
		status = field->decode( value, this );
		break;
	    }

	    const RTObject_class * super = type->_super;

	    if( super == (const RTObject_class *)0 )
	    {
		status = 0;
		break;
	    }

	    value = (*type->_super_accessor)( value );
	    type  = super;
	}

	if( status == 0 )
	    break;

	if( getFieldSeparator() == 0 )
	    break;

	status = 0;
    }

    return getFieldListFinish() != 0 && status != 0;
}
