/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTAsciiDecoding.h>

int RTAsciiDecoding::get_ushort( unsigned short & value )
{
    // We check that all significant bits fit in value by shifting some bits
    // out to the right and verifying that not too many remain. We shift one
    // bit position less than the width of value to avoid undefined operations.

    const unsigned shift = 8U * sizeof( value ) - 1U;
    unsigned long  tmp   = 0L;

    if( get_ulong( tmp ) != 0 && ( tmp >> shift ) <= 1UL )
    {
	value = (unsigned short)tmp;
	return 1;
    }

    return 0;
}
