/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTController.h>
#include <RTMessage.h>

// requeue to the appropriate priority queue a message to be delivered
// to a local actor that was previously deferred

void RTController::requeueMsg( RTMessage * message, int front )
{
    int          priority = (int)message->priority;
    RTMessageQ & queue    = internalQ[ priority ];

    if( front != 0 )
	queue.nqHead( message );
    else
	queue.nqTail( message );

    internalBits |= (short)( 1 << priority );
}
