/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTDebugger.h>

int RTDebugger::getCommand( void )
{
    static const RTDebuggerInput::CmdDesc commands[] =
    {
	{ CmdHelp,    1, "?"          },
	{ CmdAttach,  2, "attach"     },
	{ CmdCont,    1, "continue"   },
	{ CmdDetach,  1, "detach"     },
	{ CmdExit,    1, "exit"       },
	{ CmdGo,      1, "go"         },
	{ CmdHelp,    1, "help"       },
	{ CmdInfo,    1, "info"       },
	{ CmdLog,     1, "log"        },
	{ CmdStats,   1, "printstats" },
	{ CmdQuit,    1, "quit"       },
	{ CmdSaps,    2, "saps"       },
	{ CmdStats,   3, "stats"      },
	{ CmdStep,    3, "step"       },
	{ CmdSystem,  2, "system"     },
	{ CmdTasks,   1, "tasks"      },

	{ CmdInvalid, 0, (const char *)0 } // terminator
    };

    return input.getCommand( commands, CmdNone, CmdInvalid );
}
