/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTDebugger.h>
#include <RTIOMonitor.h>
#include <RTObserver.h>
#include <RTTcpSocket.h>
#include <RTTimespec.h>
#include <RTinet.h>
#include <RTtcp.h>

int RTDebugger::mainObserverLoop( void )
{
    if( ioMonitor == (RTIOMonitor *)0 )
	return 0;

    static const RTTimespec   awhile( 10L, 0L );
    RTTcpSocket             * sock;
    RTObserver              * observer;
    int                       i;

    if( ioMonitor->wait( &awhile ) <= 0 )
	return 1;

#if USE_THREADS
    if( ( ioMonitor->status( _udp ) & RTIOMonitor::CanRead ) != 0 )
#endif
    {
#if USE_THREADS
	char           anything;
	RTinet_address source_address;
	RTinet_port    source_port;

	(void)RTinet_recvfrom( _udp,
			       &anything, (int)sizeof( anything ),
			       &source_address, &source_port );
#endif

	while( useEvent() > 0 ) // > 0 as long as there are events waiting
	{
	    for( i = observers.size(); --i >= 0; )
	    {
		observer = (RTObserver *)observers[ i ];

		if( observer != (RTObserver *)0 )
		{
		    if( observer->receiveData() < 0 )
		    {
			delete observer;
			observers[ i ] = (void *)0;
		    }
		}
	    }
	    observers.resize( 0 );
	}
    }

    if( (sock = newConnection()) != (RTTcpSocket *)0 )
	sockets[ sockets.unusedIndex() ] = (void *)sock;

    for( i = sockets.size(); --i >= 0; )
    {
	sock = (RTTcpSocket *)sockets[ i ];

	if( sock != (RTTcpSocket *)0 )
	{
	    int obsPlace = observers.unusedIndex();

	    observer = findObserver( sock, obsPlace );

	    if( observer != (RTObserver *)0 )
	    {
		observers[ obsPlace ] = (void *)observer;
		sockets[ i ] = (void *)0;
	    }
	}
    }
    sockets.resize( 0 );

    for( i = observers.size(); --i >= 0; )
    {
	observer = (RTObserver *)observers[ i ];

	if( observer != (RTObserver *)0 )
	{
	    if( observer->receiveData() < 0 )
	    {
		delete observer;
		observers[ i ] = (void *)0;
	    }
	    else
		(void)observer->transmitData();
	}
    }
    observers.resize( 0 );

    return 1;
}
