/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTBindingEnd.h>
#include <RTDebugger.h>
#include <RTDiag.h>
#include <RTDiagStream.h>
#include <RTMessage.h>
#include <RTProtocol.h>

void RTDebugger::printMessage( const RTMessage * message )
{
    if( message != (RTMessage *)0 )
    {
	RTDiagStream & out   = RTDiag::out();
	RTProtocol   * port  = message->sap();
	int            index = message->sapIndex0();

	out << "  to   ";

	if( port == (RTProtocol *)0 )
	    printActor( message->receiver() );
	else
	    printPort( port, index );

	out << ":";

	const char * signalName = message->getSignalName();

	if( signalName == (const char *)0 )
	    out << "?(" << message->getSignal() << ")";
	else
	    out << signalName;

	if( port != (RTProtocol *)0 )
	{
	    RTBindingEnd from;

	    if( port->peerAt( index, from ) != 0 )
	    {
		out << "\n  from ";
		printPort( from.port, from.index );
	    }
	}

	out << "\n  data ";

#if OBJECT_ENCODE
	const RTObject_class * type = message->getType();

	if( type != (const RTObject_class *)0 )
	    (void)out.write( message->data, type );
	else
#endif
	    out << "(void *)" << message->data;

	out << "\n";
    }
}
