/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTController.h>
#include <RTExternal.h>
#include <RTMessage.h>
#include <RTObject_class.h>

void External::Base::enable( void )
{
    if( msg == (RTMessage *)0 )
    {
	RTController * controller = context();
	RTMessage    * message    = controller->newMsg();

	if( message == (RTMessage *)0 )
	{
	    controller->setError( RTController::noMem,
				  RTController::SystemService,
				  (const void *)0,
				  (const void *)0 );
	}
	else
	{
	    message->setSignal( External::Base::rti_event );
	    message->setPriority( System );
	    message->setData( (const void *)0, &RTType_void );
	    message->setDestination( getOwner(), this, 0 );

	    // This function may only be used by the thread on which the owner
	    // capsule executes so there is no danger of leaking messages here.
	    // However we assume that this store is atomic with respect to
	    // unload. It either fetches this message or the nil pointer that
	    // was previously stored in msg.
	    msg = message;
	}
    }
}
