/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTArray_class.h>
#include <RTEncoding.h>
#include <RTFieldDescriptor.h>
#include <RTObject_class.h>
#include <RTTypeModifier.h>

static int vector_encode( RTEncoding           * coding,
			  const void           * source,
			  int                    size,
			  const RTObject_class * element )
{
    RTArray_class array( size, element );

    return coding->put_indirect( source, &array );
}

int RTFieldDescriptor::encode( const void * source, RTEncoding * coding ) const
{
    const void * field = RTConstObjectOf( void, offset, source );

    if( type == (const RTObject_class *)0 )
	return 0;
    else if( modifier == (const RTTypeModifier *)0 )
	return type->encode( field, coding );
    else
    {
	int size = (*modifier->_num_elements_func)( modifier, source );

	if( modifier->_indirect != 0 )
	    return vector_encode( coding, field, size, type );
	else
	    return coding->put_array( field, size, type );
    }
}
