/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTFloat.h>

int RTFloat::div10( void )
{
    int   nonZero = 0;
    dword carry   = 0UL;
    dword quotient;

    for( int i = 0; i < mantissa_words; ++i )
    {
	quotient   = carry;
	quotient <<= bits_per_word;
	quotient  += (dword)mantissa[ i ];

	carry          = quotient % 10UL;
	quotient      /= 10UL;
	mantissa[ i ]  = (word)( word_mask & (word)quotient );

	if( quotient != 0UL )
	    nonZero = 1;
    }

    return nonZero;
}
