/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTLayerConnector.h>
#include <RTQueue.h>

RTLayerData * RTLayerConnector::registerSPP( RTController * context,
					     RTProtocol   * spp,
					     const char   * name )
{
    NameBuffer service;

    parseService( name, service );

    RTLayerConnector * connector = (RTLayerConnector *)
				   (connectors[ service.value ]);
    RTLayerData      * info;

    if( connector == (RTLayerConnector *)0 )
    {
	// add SPP to pending list
	RTQueue * queue = (RTQueue *)(pendingSPPs[ service.value ]);

	if( queue == (RTQueue *)0 )
	{
	    queue = new RTQueue;
	    (void)pendingSPPs.atPut( service.value, (void *)queue );
	}

	info = new Pending( queue, spp, name );
    }
    else
	info = connector->_registerSPP( context, spp, name );

    return info;
}
