/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTMessage.h>
#include <RTMessageQ.h>
#include <RTQFilter.h>

int RTMessageQ::filterAll( RTQFilter & filter )
{
    RTMessage ** _link    = &head;
    RTMessage  * new_tail = (RTMessage *)0;
    RTMessage  * node;
    int          count    = 0;

    while( (node = *_link) != (RTMessage *)0 )
    {
	if( filter.select( *node ) != 0 )
	{
	    *_link = node->next;
	    node->next = (RTMessage *)0;
	    filter.accept( *node );
	    ++count;
	}
	else
	{
	    new_tail = node;
	    _link = &node->next;
	}
    }
    tail = new_tail;

    return count;
}
