/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTDecoding.h>
#include <RTEncoding.h>
#include <RTObject_class.h>

static void uint_init( const RTObject_class *, void * target )
{
    *(unsigned *)target = 0U;
}

static void uint_copy( const RTObject_class *,
		       void                 * target,
		       const void           * source )
{
    *(unsigned *)target = *(const unsigned *)source;
}

#if OBJECT_DECODE
static int uint_decode( const RTObject_class *,
			void                 * target,
			RTDecoding           * coding )
{
    return coding->get_unsigned( *(unsigned *)target );
}
#endif

#if OBJECT_ENCODE
static int uint_encode( const RTObject_class *,
			const void           * source,
			RTEncoding           * coding )
{
    return coding->put_unsigned( *(const unsigned *)source );
}
#endif

const RTObject_class RTType_unsigned =
{
    (RTObject_class *)0,
    (RTSuperAccessFunction)0,
    "unsigned",
    (RTVersionId)0,
    (RTFieldOffset)sizeof( unsigned ),
    uint_init,
    uint_copy,
#if OBJECT_DECODE
    uint_decode,
#endif
#if OBJECT_ENCODE
    uint_encode,
#endif
    RTnop_destroy,
    0, (const RTFieldDescriptor *)0
};

#if OBJECT_DECODE
RTTypeInstaller unsigned_installer( RTType_unsigned );
#endif
