/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTActor.h>
#include <RTController.h>
#include <RTMessage.h>
#include <RTRootProtocol.h>

void RTProtocol::notifyBoundAt( int index, RTController * initiator )
{
    RTMessage * msg;

    if( (msg = initiator->newMsg()) == (RTMessage *)0 )
    {
	// out of memory
	initiator->setError( RTController::noMem,
			     RTController::SystemService,
			     (const void *)0,
			     (const void *)0 );
    }
    else
    {
	RTActor * owner = getOwner();

	msg->setSignal( RTRootProtocol::rti_rtBound );
	msg->setPriority( System );
	msg->setDestination( owner, this, index );

	owner->context()->receive( msg, initiator );
    }
}
