/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTActor.h>
#include <RTActorRef.h>
#include <RTRelayPort.h>

int RTRelayPort::followOut( RTBindingEnd & end,
			    RTActor      * owner,
			    int            id,
			    int            index,
			    int            size )
{
    if( index < 0 )
    {
	// invalid index
    }
    else
    {
	RTActorRef * ref    = owner->getReference();
	int          direct = directUse( ref, id );

	if( index < direct )
	{
	    // The given index was reserved by the owner of my owner's
	    // homeReference.
	    return ref->_followOut( end, owner, id, index );
	}
	else if( index < size && _importers != (RTActorRef **)0 )
	{
	    int i = index - direct;

	    if( (ref = _importers[ i ]) != (RTActorRef *)0 )
	    {
		index = 0;

		while( --i >= 0 )
		    if( ref == _importers[ i ] )
			++index;

		return ref->_followOut( end, owner, id, index );
	    }
	}
    }

    return 0;
}
