/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTFieldDescriptor.h>
#include <RTObject_class.h>
#include <RTSequenceOf.h>
#include <RTTypeModifier.h>
#include <RTnew.h>

static RTDataObject * _access( RTSequenceOf * target )
{
    return target;
}

static void _init( const RTObject_class *, void * target )
{
    (void)new( target ) RTSequenceOf;
}

static void _copy( const RTObject_class *,
		   void                 * target,
		   const void           * source )
{
    (void)new( target ) RTSequenceOf( *(const RTSequenceOf *)source );
}

int RTSequenceOf_size( const RTTypeModifier *, const void * source )
{
    const RTSequenceOf * data = (const RTSequenceOf *)source;

    return data->size;
}

static const RTTypeModifier array_modifier =
{
    RTSequenceOf_size, 0, 1
};

static const RTFieldDescriptor _fields[] =
{
    {
	"size",
	RTOffsetOf( RTSequenceOf, size ),
	&RTType_int,
	(const RTTypeModifier *)0
    },
    {
	"array",
	RTOffsetOf( RTSequenceOf, array ),
	&RTType_RTpRTDataObject,
	&array_modifier
    }
};

const RTObject_class RTSequenceOf::classData =
{
    &RTType_RTDataObject,
    (RTSuperAccessFunction)_access,
    "RTSequenceOf",
    (RTVersionId)0,
    (RTFieldOffset)sizeof( RTSequenceOf ),
    _init,
    _copy,
#if OBJECT_DECODE
    RTstruct_decode,
#endif
#if OBJECT_ENCODE
    RTstruct_encode,
#endif
    RTDataObject_destroy,
    2, _fields
};

#if OBJECT_DECODE
RTTypeInstaller RTSequenceOf_installer( RTType_RTSequenceOf );
#endif

const RTObject_class * RTSequenceOf::getClassData( void ) const
{
    return &RTSequenceOf::classData;
}
