/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTIOMonitor.h>
#include <RTTcpSocket.h>

RTTcpSocket::State RTTcpSocket::state( void )
{
    if( _state == SynSent )
    {
	if( _monitor != (RTIOMonitor *)0 )
	{
	    if( _monitor->status( _sd ) != 0 )
	    {
		if( try_connect() == 0 )
		    close(); // failed

		else if( _state == Established )
		    _monitor->remove( _sd, RTIOMonitor::CanWrite |
					   RTIOMonitor::Exception );
	    }
	}
	else
	{
	    RTIOMonitor monitor;

	    monitor.add( _sd, RTIOMonitor::CanWrite |
			      RTIOMonitor::Exception );

	    _monitor = &monitor;

	    if( monitor.status( _sd ) != 0 )
	    {
		if( try_connect() == 0 )
		    close(); // failed
	    }

	    _monitor = (RTIOMonitor *)0;
	}
    }

    return _state;
}
