/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTTimerActor.h>
#include <RTTimerNode.h>

int RTTimerActor::nextTimeout( RTTimespec & when )
{
    int result = 1;

#if USE_THREADS
    RTTimerNode::critical.enter();
#endif

    if( pendingRelative.length() == 0 )
    {
	if( pendingAbsolute.length() == 0 )
	    result = 0;
	else
	    // only absolute requests pending
	    pendingAbsolute.headTime( when );
    }
    else
    {
	pendingRelative.headTime( when );
	when += currentOffset;

	if( pendingAbsolute.length() != 0 )
	{
	    RTTimespec absTime;

	    pendingAbsolute.headTime( absTime );

	    if( absTime < when ) //lint !e909
	    {
		// both relative and absolute requests pending
		// and absolute is sooner
		when = absTime;
	    }
	}
    }

#if USE_THREADS
    RTTimerNode::critical.leave();
#endif

    return result;
}
