/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTAsciiDecoding.h>
#include <RTDaemon.h>
#include <RTMemoryInBuffer.h>
#include <RTMemoryUtil.h>
#include <RTToolsetObserver.h>
#include <RTUnknownObject.h>

void RTToolsetObserver::handleInject( void )
{
    TO_injectMsg         * injMsg = (TO_injectMsg         *)structInfo.ptr;
    void                 * data   = (void                 *)0;
    const RTObject_class * type   = (const RTObject_class *)0;
    int                    dataLen;

    if( (dataLen = RTMemoryUtil::strlen( injMsg->data )) > 0 )
    {
	RTMemoryInBuffer source( injMsg->data, dataLen );
	RTAsciiDecoding  decoder( &source );

	if( decoder.get( &data, &type ) == 0 )
	{
	    sendResultCode( RES_BAD_MESSAGE );
	    return;
	}
    }

    if( type == &RTType_RTUnknownObject )
    {
	sendResultCode( RES_BAD_MESSAGE );
    }
    else if( daemon->inject( injMsg->inwards,
			     injMsg->signal,
			     injMsg->prio,
			     data, type ) == 0 )
	sendResultCode( RES_BAD_MESSAGE );
    else
	sendResultCode( RES_OK );

    if( type != (const RTObject_class *)0 )
	type->destroy( data, RTObject_class::DestroyAndDeallocate );
}
