/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTMain.h>
#include <RTObject_class.h>
#include <RTWrapper.h>

RTWrapper & RTWrapper::operator=( const RTWrapper & rhs )
{
    if( this != &rhs )
    {
	RTMain::lock();

	Handle * old_handle = handle;
	int      old_count  = old_handle->ref_count -= 1;

	handle = rhs.handle;

	handle->ref_count += 1;

	RTMain::unlock();

	if( old_count == 0 )
	{
	    old_handle->type->destroy( old_handle->data,
				       RTObject_class::DestroyOnly );
	    delete [] old_handle;
	}
    }

    return *this;
}
