/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#ifndef __RTDebuggerInput_h__
#define __RTDebuggerInput_h__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTConfig_h__
#include <RTConfig.h>
#endif

class RTDebuggerInput
{
public:
    struct CmdDesc
    {
	int          cmd;
	int          minAbbr;
	const char * name;
    };

		    RTDebuggerInput( void );
		    ~RTDebuggerInput( void );

    void            setPrompt( const char * );
    void            pushInput( const char * );
    int             getNumber( void );
    void            getEol( void );
    int             getString( char * buf, int buf_size );
    int             getCommand( const CmdDesc *, int none, int invalid );

private:
    enum          { UngetMax = 1 };

    int             need_prompt;
    const char    * prompt;
    int             unget_size;
    char            unget_buffer[ UngetMax ];
    const char    * input;

    int             getChar( void );
    void            ungetChar( char );
    int             nextChar( void );
    static RTS_INLINE
    int             isEol( int );

    // unavailable methods
    RTDebuggerInput( const RTDebuggerInput & );
    RTDebuggerInput & operator=( const RTDebuggerInput & );
};

#if RTS_INLINES
#include <RTDebuggerInput.inl>
#endif

#endif // __RTDebuggerInput_h__
