/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#ifndef __RTElasticArray_h__
#define __RTElasticArray_h__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTConfig_h__
#include <RTConfig.h>
#endif

class RTElasticArray
{
protected:
    int                 _size;
    void             ** _contents;

public:
    explicit            RTElasticArray( int initial_size = 0 );
			RTElasticArray( const RTElasticArray & );
			~RTElasticArray( void );

    RTS_INLINE int      size( void ) const;
    int                 compact( void );
    void                resize( int min_size );
    int                 unusedIndex( void );
    int                 unusedIndex( int minimum );

    RTS_INLINE void  *& operator[]( int );

    RTElasticArray & operator=( const RTElasticArray & );
};

#if RTS_INLINES
#include <RTElasticArray.inl>
#endif

#endif // __RTElasticArray_h__
