/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#ifndef __RTIOMonitor_h__
#define __RTIOMonitor_h__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTConfig_h__
#include <RTConfig.h>
#endif

struct RTTimespec;

class RTIOMonitor
{
public:
		RTIOMonitor( void );
		~RTIOMonitor( void );

    // One or more of these values are or-ed together to form the status
    // argument of add() and remove() or the result of status().

    enum
    {
	CanRead   = 1,
	CanWrite  = 2,
	Exception = 4
    };

    void        add( int fd, int status );
    void        remove( int fd, int status );

    int         status( int fd );

    int         anyRegistered( void ) const;
    int         wait( const RTTimespec * timeout );

private:
    struct Entry
    {
	unsigned fd;
	int      bits;
    };

    Entry     * _entries;
    unsigned    _used;
    unsigned    _space;

    enum
    {
	RequestMask     = CanRead | CanWrite | Exception
      , ResultShift     = 3
      , ResultCanRead   = CanRead   << ResultShift
      , ResultCanWrite  = CanWrite  << ResultShift
      , ResultException = Exception << ResultShift
    };

private:
    // unavailable methods
    RTIOMonitor & operator=( const RTIOMonitor & );
    RTIOMonitor( const RTIOMonitor & );
};

#endif // __RTIOMonitor_h__
