/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#ifndef __RTProtocolAdapter_h__
#define __RTProtocolAdapter_h__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTConfig_h__
#include <RTConfig.h>
#endif

struct RTProtocolDescriptor;

class RTProtocolAdapter
{
public:
    RTProtocolAdapter( void );
    ~RTProtocolAdapter( void );

    void adapt( const RTProtocolDescriptor  * source,
		const RTProtocolDescriptor  * target,
		const int                  ** sourceMap,
		const int                  ** targetMap );

private:
    struct Entry
    {
	const RTProtocolDescriptor * source;
	const RTProtocolDescriptor * target;
	int                          maps[ 1 /* 0 or more */ ];
    };

    Entry ** entry;
    int      size;
    int      used;
};

#endif // __RTProtocolAdapter_h__
