/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#ifndef __RTTimerActor_h__
#define __RTTimerActor_h__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTActor_h__
#include <RTActor.h>
#endif

#ifndef __RTTimerList_h__
#include <RTTimerList.h>
#endif

#ifndef __RTTimespec_h__
#include <RTTimespec.h>
#endif

#ifndef __RTTiming_h__
#include <RTTiming.h>
#endif

class RTTimerNode;

class RTTimerActor : public RTActor
{
public:
			  RTTimerActor( RTController *, RTActorRef * );
    virtual               ~RTTimerActor( void );

    RTS_INLINE
    static RTTimerActor * soleInstance( void );

    virtual void          rtsBehavior( int, int );

    RTS_INLINE int        anyPending( void ) const;
    int                   numPending( void ) const;
    int                   nextTimeout( RTTimespec & );

    virtual int           designLevel( void ) const;

    static  const RTActorClass     classData;
    virtual const RTActor_class  * getActorData( void ) const;

    void                  informIn( RTTimerNode * );
    void                  informAt( RTTimerNode * );
    void                  informAgain( RTTimerNode * );
    void                  cancel( RTTimerNode * );
    void                  cancelAll( Timing::Base * );

    void                  adjustTimeBegin( void );
    void                  adjustTimeEnd( const RTTimespec & delta,
					 RTController     * originator );
    static void           getRelativeClock( RTTimespec & );

protected:
    RTTimerList           pendingAbsolute;
    RTTimerList           pendingRelative;

    static RTTimespec     currentOffset;

    void                  start( void );
    void                  stop( void );

    void                  sendTimeouts( void );

    static const RTActor_class rtg_class;

private:
    static const RTStateId     rtg_parent_state[];

    static RTTimerActor * _soleInstance;

    // unavailable methods
    RTTimerActor( const RTTimerActor & );
    RTTimerActor & operator=( const RTTimerActor & );
}; //lint !e1712

#if RTS_INLINES
#include <RTTimerActor.inl>
#endif

#endif // __RTTimerActor_h__
