/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTDiag.h>
#include <RTSyncObject.h>

#include <errno.h>

void RTSyncObject::wait( void )
{
    enter();

    errno = EINTR;

    if( signalled == 0 )
    {
	int rc = pthread_cond_wait( &cv, &mutex );

	// POSIX, it seems, is a collection of 'standards'. Some implementions
	// use the return value to indicate the reason the call failed, others
	// simply return -1 and store the reason in errno. The following works
	// with all implementations encountered thus far.

	if( rc == 0 )
	{
	    // cv was signalled
	}
	else if( rc == ETIMEDOUT || errno == ETIMEDOUT )
	{
	    // timeout
	}
	else if( rc == EINTR || errno == EINTR )
	{
	    // interrupted
	}
	else
	{
	    RTDiag::panic( "pthread_cond_wait" );
	}
    }

    signalled = 0;

    leave();
}
