/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTDebuggerInput.h>
#include <RTDiag.h>
#include <RTDiagStream.h>
#include <RTNucleus.h>

extern "C"
{

#include <ctype.h>

#ifdef PLUS_MNT

#include <conio.h>

static inline int get_char( void )
{
    while( ! _kbhit() )
	NU_Sleep( 1U );

    return _getch();
}

#else

#include <plus/uart.h>

static inline int get_char( void )
{
    int ch;

    while( (ch = UART_Get_Char( SMC1 )) == BUF_EMPTY )
	NU_Sleep( 1U );

    return ch;
}

#endif // PLUS_MNT

} // extern "C"

int RTDebuggerInput::nextChar( void )
{
    enum Status
    {
	Incomplete, Complete, Full
    };

    static char     buffer[ 128 ];
    static Status   status = Incomplete;
    static unsigned read   = 0U;
    static unsigned write  = 0U;
    int             ch;

    if( status == Incomplete )
    {
	RTDiagStream & out = RTDiag::out();

	for(;;)
	{
	    ch = get_char();

	    if( ch == '\r' || ch == '\n' )
	    {
		ch = '\n';
		out << "\n";
	    }
	    else if( ch == '\b' )
	    {
		if( read != write )
		{
		    write += sizeof( buffer ) - 1U;
		    write %= sizeof( buffer );
		    out << "\b \b";
		}
		continue;
	    }
	    else if( iscntrl( ch ) )
		continue;
	    else
	    {
		if( isprint( ch ) )
		{
		    char echo[ 2 ];

		    echo[ 0 ] = (char)ch;
		    echo[ 1 ] = '\0';
		    out << echo;
		}
	    }

	    buffer[ write++ ] = (char)ch;
	    write %= sizeof( buffer );

	    if( ch == '\n' )
	    {
		status = Complete;
		break;
	    }
	    else if( read == write )
	    {
		status = Full;
		break;
	    }
	}
    }

    ch = buffer[ read++ ];
    read %= sizeof( buffer );

    if( read == write || status == Full )
	status = Incomplete;

    return ch;
}
