/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#ifndef __RTNucleus_h__
#define __RTNucleus_h__ included

#ifndef __RTConfig_h__
#include <RTConfig.h>
#endif

extern "C"
{
#include <plus/nucleus.h>

extern NU_MEMORY_POOL System_Memory;
}

class RTNucleus
{
public:
    typedef char Name[ NU_MAX_NAME ];

    enum NameKind
    {
	Mutex, SyncObject, Thread
    };

    static void           makeName( Name, NameKind, const void * location );

    static long           ticks_per_second;
    static long           clock_period;

#if HAVE_INET
    static NU_MEMORY_POOL network_pool;
#endif
};

#endif // __RTNucleus_h__
