/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTNucleus.h>

static const char hex[] = "0123456789abcdef";

void RTNucleus::makeName( Name name, NameKind kind, const void * location )
{
    unsigned long value = (unsigned long)location;

    for( int i = NU_MAX_NAME; --i > 0; )
    {
	name[ i ] = hex[ value & 0xFUL ];
	value >>= 4;
    }

    switch( kind )
    {
    case Mutex:      name[ 0 ] = 'M'; break;
    case SyncObject: name[ 0 ] = 'S'; break;
    case Thread:     name[ 0 ] = 'T'; break;
    default:         name[ 0 ] = '?'; break;
    }
}
