/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#ifdef PRAGMA
#pragma implementation "RTMain.h"
#pragma implementation "RTMain.inl"
#pragma implementation "RTSystemDescriptor.h"
#endif

#include <RTMain.h>
#include <RTOse.h>
#include <RTSystemDescriptor.h>

static int ( * main_thread_func )( void );

OS_PROCESS( main_thread )
{
    (void)(*main_thread_func)();

    kill_proc( current_process() );
}

int RTMain::execute( void )
{
    // Initialize address of function to be executed. We don't need to worry
    // about concurrency here because it will only ever have this value.
    main_thread_func = &RTMain::mainLine;

    // Create the dynamic thread that will become the main thread.
    PROCESS proc = create_process( OS_PRI_PROC,
				   (char *)"main_thread",
				   main_thread,
				   _system->mainStackSize,
				   _system->mainPriority,
				   (OSTIME)0,
				   (PROCESS)0,
				   (OS_redir_entry *)0,
				   (OSVECTOR)0,
				   (OSUSER)0 );

    ose_start( proc );

    return 0;
}
