/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTDiag.h>
#include <RTSyncObject.h>
#include <RTTimespec.h>

static int  initialized   = 0;
static long nsec_per_tick;

void RTSyncObject::timedwait( const RTTimespec & expireTime )
{
    int  err;
    long delta;

    if( ! initialized )
    {
	timespec now;

	sc_gclock( &now, (unsigned long *)&nsec_per_tick, &err );

	if( err != RET_OK )
	    RTDiag::panic( "sc_gclock" );

	RTAssert( nsec_per_tick > 0 );

	initialized  = 1;
    }

    if( (delta = expireTime.ticksFromNow( nsec_per_tick )) > 0 )
    {
	sc_pend( &mbox, delta, &err );

	if( err != RET_OK && err != ER_TMO )
	    RTDiag::panic( "sc_pend" );
    }
}
